Linux-NVME Archive on lore.kernel.org
 help / color / mirror / Atom feed
From: Martin Wilck <martin.wilck@suse.com>
To: Shin'ichiro Kawasaki <shinichiro.kawasaki@wdc.com>
Cc: Chaitanya Kulkarni <Chaitanya.Kulkarni@wdc.com>,
	Hannes Reinecke <hare@suse.de>, Daniel Wagner <dwagner@suse.de>,
	linux-block@vger.kernel.org, linux-nvme@lists.infradead.org,
	Martin Wilck <mwilck@suse.com>
Subject: [PATCH 3/3] nvme: add test for controller rescan under I/O load
Date: Thu, 22 Aug 2024 21:38:14 +0200	[thread overview]
Message-ID: <20240822193814.106111-3-mwilck@suse.com> (raw)
In-Reply-To: <20240822193814.106111-1-mwilck@suse.com>

Add a test that repeatedly rescans nvme controllers while doing IO
on an nvme namespace connected to these controllers. The purpose
of the test is to make sure that no I/O errors or data corruption
occurs because of the rescan operations.

Signed-off-by: Martin Wilck <mwilck@suse.com>
---
 tests/nvme/053 | 56 ++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/nvme/rc  | 18 ++++++++++++++++
 2 files changed, 74 insertions(+)
 create mode 100755 tests/nvme/053

diff --git a/tests/nvme/053 b/tests/nvme/053
new file mode 100755
index 0000000..41dc8f2
--- /dev/null
+++ b/tests/nvme/053
@@ -0,0 +1,56 @@
+#!/bin/bash
+# SPDX-License-Identifier: GPL-3.0+
+# Copyright (C) 2024 Martin Wilck, SUSE LLC
+
+. tests/nvme/rc
+
+DESCRIPTION="test controller rescan under I/O load"
+TIMED=1
+: "${TIMEOUT:=60}"
+
+rescan_controller() {
+	local finish
+
+	[[ -f "$1/rescan_controller" ]] || {
+		echo "cannot rescan $1"
+		return 1
+	}
+
+	finish=$(($(date +%s) + TIMEOUT))
+	while [[ $(date +%s) -le $finish ]]; do
+		# sleep interval between 0.1 and 5s
+		usleep "$(((RANDOM%50 + 1)*100000))"
+		echo 1 >"$1/rescan_controller"
+	done
+}
+
+test_device() {
+	local -a ctrls
+	local c
+
+	echo "Running ${TEST_NAME}"
+	ctrls=($(_nvme_get_ctrl_list))
+
+	_run_fio_verify_io --filename="$TEST_DEV" --time_based &> "$FULL" &
+
+	for c in "${ctrls[@]}"; do
+		rescan_controller "$c" &
+	done
+
+	while true; do
+		wait -n &>/dev/null
+		st=$?
+		case $st in
+			127)
+				break
+				;;
+			0)
+				;;
+			*)
+				echo "child process exited with $st!"
+				;;
+		esac
+	done
+
+	echo "Test complete"
+}
diff --git a/tests/nvme/rc b/tests/nvme/rc
index e7d2ab1..93b0571 100644
--- a/tests/nvme/rc
+++ b/tests/nvme/rc
@@ -192,6 +192,24 @@ _test_dev_nvme_nsid() {
 	cat "${TEST_DEV_SYSFS}/nsid"
 }
 
+_nvme_get_ctrl_list() {
+	local subsys
+	local c
+
+	subsys=$(readlink  "${TEST_DEV_SYSFS}/device/subsystem")
+	case $subsys in
+		*/nvme)
+			readlink -f "${TEST_DEV_SYSFS}/device"
+			;;
+		*/nvme-subsystem)
+			for c in "${TEST_DEV_SYSFS}"/device/nvme*; do
+				[[ -L "$c" ]] || continue
+				[[ -f "$c/dev" ]] && readlink -f "$c"
+			done
+			;;
+	esac
+}
+
 _nvme_calc_rand_io_size() {
 	local img_size_mb
 	local io_size_kb
-- 
2.46.0



  parent reply	other threads:[~2024-08-22 19:38 UTC|newest]

Thread overview: 13+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2024-08-22 19:38 [PATCH 1/3] blktests: nvme: skip passthru tests on multipath devices Martin Wilck
2024-08-22 19:38 ` [PATCH 2/3] blktests: nvme/032: skip on non-PCI devices Martin Wilck
2024-08-23  6:46   ` Daniel Wagner
2024-08-22 19:38 ` Martin Wilck [this message]
2024-08-23  6:45   ` [PATCH 3/3] nvme: add test for controller rescan under I/O load Daniel Wagner
2024-08-23  6:50     ` Martin Wilck
2024-08-23  7:03       ` Daniel Wagner
2024-08-23 10:18   ` Nilay Shroff
2024-08-23 13:39     ` Nilay Shroff
2024-08-23 14:49     ` Martin Wilck
2024-08-23  6:35 ` [PATCH 1/3] blktests: nvme: skip passthru tests on multipath devices Daniel Wagner
2024-08-23  6:41   ` Martin Wilck
2024-08-23  7:07     ` Daniel Wagner

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20240822193814.106111-3-mwilck@suse.com \
    --to=martin.wilck@suse.com \
    --cc=Chaitanya.Kulkarni@wdc.com \
    --cc=dwagner@suse.de \
    --cc=hare@suse.de \
    --cc=linux-block@vger.kernel.org \
    --cc=linux-nvme@lists.infradead.org \
    --cc=mwilck@suse.com \
    --cc=shinichiro.kawasaki@wdc.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox